<?php

/* to unify look of post in widgets */
if(!function_exists('a13_widget_posts')){
    function a13_widget_posts($r, $instance, $type = 'normal' ){
        while ($r->have_posts()) : $r->the_post();
            $page_title = get_the_title();

            $img = a13_make_post_image( get_the_ID(), 'apollo-sidebar-size');
            $full = (!$img)? '' : ' full';

            echo '<div class="item clearfix'.esc_attr($full).'">';

            if(strlen($img)){
                echo '<a class="thumb" href="' . esc_url(get_permalink()) . '" title="' . esc_attr($page_title) . '">' . $img . '</a>';
            }

            echo '<a class="post-title" href="' . esc_url(get_permalink()) . '" title="' . esc_attr($page_title) . '">' . $page_title . '</a>';
            if($type === 'popular'){
                echo '<a class="comments" href="' . esc_url(get_comments_link()) . '" title="' . esc_attr(get_comments_number() . ' ' . __fe( 'comment(s)' )). '">'.get_comments_number().' '.__fe( 'comment(s)' ).'</a>';
            }
            else{
                echo a13_posted_on(false);
            }

            //if user want excerpt also and post is not password protected
            if(!empty( $instance['content'] ) && !post_password_required()){
                echo  '<a class="content" href="' . esc_url(get_permalink()) . '" title="' . esc_attr($page_title) . '">';
                $text = get_the_content('');
                $text = strip_shortcodes( $text );
                $text = wp_trim_words( $text, 30, '' );
                echo $text;
                echo '</a>';
            }
            echo '</div>';

        endwhile;
    }
}


if(!function_exists('a13_add_sidebars')){
    function a13_add_sidebars() {
        /**
         * Register widgets areas
         */
        // Shown on blog
        register_sidebar( array(
            'name' => __be( 'Blog sidebar' ),
            'id' => 'blog-widget-area',
            'description' => __be( 'Widgets from this sidebar will appear on blog, search results, archive page and 404 error page.' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget' => '</div>',
            'before_title' => '<h3 class="title"><span>',
            'after_title' => '</span></h3>',
        ) );
        register_sidebar( array(
            'name' => __be( 'Post sidebar' ),
            'id' => 'post-widget-area',
            'description' => __be( 'Widgets from this sidebar will appear in single posts.' ),
            'before_widget' => '<div id="%1$s" class="widget %2$s">',
            'after_widget' => '</div>',
            'before_title' => '<h3 class="title"><span>',
            'after_title' => '</span></h3>',
        ) );

    }
}

add_action( 'widgets_init', 'a13_add_sidebars' );
?>