jQuery.noConflict();

function injectStyles(rule) {
    jQuery("#ios_fallback").parent().remove();
  var div = jQuery("<div />", {
    html: '<div id="ios_fallback">&shy;<style>' + rule + '</style></div>'
  }).appendTo("body");    
}
(function($, window, document){
    "use strict";
    
    Modernizr.addTest('highresdisplay', function(){
        if (window.matchMedia) {
            var mq = window.matchMedia("only screen and (-moz-min-device-pixel-ratio: 1.3), only screen and (-o-min-device-pixel-ratio: 2.6/2), only screen and (-webkit-min-device-pixel-ratio: 1.3), only screen and (min-device-pixel-ratio: 1.3), only screen and (min-resolution: 1.3dppx)");
            return (mq && mq.matches);
        }
        return false;
    });
 
    
    var A13,
        body                    = document.body,
        $body                   = $(body),
        $window                 = $(window),
        $header                 = $('#header'),
        $footer                 = $('#footer'),
        hash_from_url           = window.location.hash,
        collapsed_items_count   = 0,
        max_items_count         = $('.main-page-slider').data('max_tiles_count') > 0 ? $('.main-page-slider').data('max_tiles_count') : 1,
        min_item_width          = $('.main-page-slider').data('min_tile_width') > 0 ? $('.main-page-slider').data('min_tile_width') : 1,
        initial_open            = ($('.main-page-slider').data('initial_open') != 'off'),
        $logo                   = $('#logo'),
        G                       = ApolloParams,
        page_slider_beforeinit  = false,
        page_slider_afterinit   = false,
        main_slider_initiated   = false,
        map_initialized         = false,
        block_initializing_map  = false,
        menu_is_opening         = false,
        isHDScreen              = Modernizr.highresdisplay,
        isTouchScr              = Modernizr.touch,
        overlay_anim_config     = {},
        slides_cache            = [],
        a13_carousels           = [],
        slides_cache_loaded     = false,
        menu_icon;

    overlay_anim_config.single = {
        'css':"width:100%;height:100%;position:absolute;top:0;left:0;opacity:0;",
        'vreset':{'opacity':'0','rotateX': '90deg'},
        'opening':{'opacity':'1','rotateX': '0deg'},
        'closing':{'opacity':'0','rotateX': '90deg'} 
    };
    
    $(document).on('touchmove',function(e){
        if( !$body.hasClass('no_custom_scroll') ){
            e.preventDefault();
        }
    });
        
    window.A13 = {
        rise : function(){
            
            //cookie for HIGH DPI screens
            if( isHDScreen ){
                var d = new Date(),
                    expires;
                d.setTime(d.getTime()+(365*24*60*60*1000)); //one year
                expires = d.toGMTString();
                document.cookie="a13_screen_size=high; expires="+expires+"; path=/";
            }
            
            A13.header.init();
            A13.startAll();
            
            A13.page_slider.init();
            A13.carousel.init();
            A13.manage_url_hash();
            $window.trigger( 'resize' );
        },
        
        a13_submit_comment : function(){
            var commentform=$('#commentform'), // find the comment form
                valid = true,
                email_regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
            
            //remove old notifications
            commentform.find('#comment-status').fadeOut().remove();
            
            // add info panel before the form to provide feedback or errors
            commentform.prepend('<div id="comment-status" ></div>'); 
            
            //remove error class from inputs
            commentform.find('.wpcf7-not-valid').each( function(){ $(this).removeClass('wpcf7-not-valid'); } );
            
            //validate fields
            if( $('#author').length && $('#author').val() == '' ){
                valid = false;
                $('#author').addClass('wpcf7-not-valid');
            }
            
            if( $('#comment').val() == '' ){
                valid = false;
                $('#comment').addClass('wpcf7-not-valid');
            }
            
            if( $('#email').length && !email_regex.test( $('#email').val() ) ){
                valid = false;
                $('#email').addClass('wpcf7-not-valid');
            }
            
            if(!valid){
                return false;
            }
            
            var statusdiv=$('#comment-status'); // define the infopanel
            //serialize and store form data in a variable
            var formdata=commentform.serialize();
            //Add a status message
            statusdiv.html('<p>Processing...</p>');
            //Extract action URL from commentform
            var formurl=commentform.attr('action');
            //Post Form with data
            $.ajax({
                type: 'post',
                url: formurl,
                data: formdata,
                error: function(XMLHttpRequest, textStatus, errorThrown)
                    {
                        statusdiv.html('<p class="ajax-error" >You might have left one of the fields blank, or be posting too quickly</p>');
                    },
                success: function(data, textStatus){
                    if(data == "success" || textStatus == "success"){
                        statusdiv.html('<p class="ajax-success" >Thanks for your comment. We appreciate your response.</p>');
                        commentform.find('textarea[name=comment]').val('');
                    }else{
                        statusdiv.html('<p class="ajax-error" >Please wait a while before posting your next comment</p>');
                        commentform.find('textarea[name=comment]').val('');
                    }
                }
            });
            $("#comment-submit").blur();
            return false;
        },
        manage_url_hash : function(){
            if( hash_from_url != '' ){
                    // go to place pointed by hash in url
                var slide = $(hash_from_url).closest('.owl-item'),
                    slide_i = slide.index(),
                    opened = window.A13.page_slider.open_slide(slide);
                    
                if( !opened ){
                    $('.main-page-slider').data('owlCarousel').jumpTo( slide_i );
                }
                //history.pushState("", document.title, window.location.pathname + window.location.search);//remove hash
                
            }
        },
        startAll : function(){
            var ipad = /iPad/i.test(navigator.userAgent);
			if (ipad) {
				
				$('body').addClass('ipad');
				
			}
            
            //comment form
            $('#commentform').on('submit',function(){ return A13.a13_submit_comment();} );
            $('.a13_row_container').on('submit','#commentform',function(){ return A13.a13_submit_comment();} );
            
   
            $(".to_scroll").each( function(){
                var theme_name = $(this).hasClass('dark') ? "minimal" : "minimal-dark",
                    always_show = $(this).hasClass('mm-panel') ? 1 : 0;

                $(this).mCustomScrollbar({
        			theme:theme_name,
                    mouseWheel:{ scrollAmount: G.mousewheel_speed },
                    alwaysShowScrollbar: always_show,
                    
        		});
            } );
            
            //social ribbons
            var speed = 300,
			easing = mina.backout;

    		[].slice.call ( document.querySelectorAll( '.social_ribbon > a' ) ).forEach( function( el ) {
                var s = Snap( el.querySelector( 'svg' ) ), path = s.select( 'path' ),pathConfig = {};
                if ( path ){
                    pathConfig = {
    					from : path.attr( 'd' ),
    					to : el.getAttribute( 'data-path-hover' )
    				};
                    el.addEventListener( 'mouseenter', function() {
        				path.animate( { 'path' : pathConfig.to }, speed, easing );
        			} );
        
        			el.addEventListener( 'mouseleave', function() {
        				path.animate( { 'path' : pathConfig.from }, speed, easing );
        			} );
                }
    
    			
    		} );
            
            //scroll
            $window.scroll( debounce( function(){
                var no_custom_scroll = $body.hasClass('no_custom_scroll'),
                    scroll_Top = $window.scrollTop(),
                    w_h = $window.height();
                //slider nav
                if(no_custom_scroll){
                    $('.main-page-slider>.owl-controls .owl-buttons>div').velocity({'top': (( w_h / 2 ) - 160 + scroll_Top) +'px' },{duration:150});
                    $('.a13_tile_content').velocity( { 'padding-top' : scroll_Top + 'px' } );
                }
            },100));
            
            
            //resize
            $window.resize( debounce( function(){
                
                var a13_fill_viewport_height = $('.owl_row_wrap').height(),
                    opened_tiles = $('#mid').hasClass('a13_opened'),
                    w_w = $window.width(),
                    w_h = $window.height();

                //hack for older IOS
                injectStyles('#mid{height: '+ (w_h - 290) +'px;}body.no_custom_scroll #mid{height: '+ (w_h - 210) +'px;}body.no_custom_scroll .main-page-slider{height: '+ (w_h - 80) +'px;}body.no_custom_scroll .main-page-slider.owl-theme>.owl-controls .owl-buttons>div {top: '+ ((w_h/2) - 160) +'px;}.people_slide_content_wrapper{padding-top: '+ ((w_h/2) - 180) +'px;}@media only screen and (max-width: 1080px) {.people_slide_content_wrapper{height: '+ w_h +'px;}.people-image {height: '+ ((w_h*0.3) - 5) +'px;}.people_featured_image { height: '+ ((w_h*0.3) - 5) +'px;}}:not(.a13_testimonial_cloud_interior) .owl_row_wrap,.a13_row_container{height: '+ (w_h - 290) +'px;}:not(.a13_testimonial_cloud_interior) .owl_row_wrap.pure_page_wrapper{height: '+ (w_h - 330) +'px;}body.no_custom_scroll #mid .owl_row_wrap{height: '+ (w_h - 80) +'px;}body.no_custom_scroll #mid .owl_row_wrap.pure_page_wrapper{height: '+ (w_h - 120) +'px;}body.no_custom_scroll #mid .main-page-slider>div>div.owl-wrapper,body.no_custom_scroll #mid .a13_tile,body.no_custom_scroll .main-page-slider .a13_row_container{height: '+ (w_h - 210) +'px;}');
                
                //always fill the viewport    
                $('.a13_fill-viewport').css({'min-height':a13_fill_viewport_height+'px'});
                
                
                //recalculate main page slider
                var slider_w = $('.owl-wrapper-outer').outerWidth(),
                    total_tiles = $('.main-page-slider .a13_tile').length,
                    class_to_add = '',
                    collapsed_slider_sesttings = {};
                    
                 
                collapsed_items_count = Math.min(Math.floor(slider_w/min_item_width),max_items_count);
                collapsed_slider_sesttings = {items:collapsed_items_count, singleItem: false,navigationText: ['<div></div>','<div></div>']};
                class_to_add = "a13psic_"+collapsed_items_count;
                
                $('#mid').removeClass( "a13psic_1 a13psic_2 a13psic_3 a13psic_4 a13psic_5 a13psic_6 " ).addClass( class_to_add );
                
                if( !opened_tiles ){
                
                    $('.main-page-slider .a13_tile').velocity({'width':(slider_w/collapsed_items_count)+'px'},{duration:500});
                    $('.main-page-slider .owl_item').velocity({'width':(slider_w/collapsed_items_count)+'px'},{duration:500});
                    $('.main-page-slider').data('owlCarousel').reinit(collapsed_slider_sesttings);
                }
                
                
                
                //tile_threshold
                if( w_w < G.tile_threshold && opened_tiles ){
                    $('.main-page-slider .owl_row_wrap.with_tile').addClass( 'super_narrow' );
                }else{
                    $('.main-page-slider .owl_row_wrap.with_tile').removeClass( 'super_narrow' );
                }
                
               
                
                //inerior carousel
                if($('#mid').hasClass('update_carousels')){
                    $.each( a13_carousels, function( index, owl ) {
                          
                        if ( owl != undefined ){
                            A13.carousel.refresh(owl );
                        }
                    });
                }
                
                
                //submenu button
                $('.mm-subopen','#mobile_menu').each( function(){
                    var item_w = $(this).next('a').find('span').width();
                    
                    $(this).css({'right':'calc(50% - '+( ( item_w ) + 20 )+'px)'});
                } );
                
                if( w_h < G.mobile_h_threshold || w_w < G.mobile_w_threshold ){
                    
                        $body.addClass('no_custom_scroll');
                                            
                        $('.mobile_menu_switch').velocity({'top':'10px'});
                        
                        var slide_h = $('.main-page-slider>.owl-wrapper-outer>.owl-wrapper>.owl-item.active>.owl_row_wrap>.a13_row_container>.mCustomScrollBox>.mCSB_container').height();
                        if( $('.pure_page_wrapper').length ){
                            slide_h = $('.pure_page_wrapper>.mCustomScrollBox>.mCSB_container').height();
                        }
                        
                        $('.main-page-slider').velocity({'height':slide_h+'px'},200);
                        
                        $('.a13_row_container').mCustomScrollbar("update");
                        
                }else{
                    if( $body.hasClass('no_custom_scroll') ){
                        $body.removeClass('no_custom_scroll');
                        
                        $('.mobile_menu_switch').velocity({'top':'44px'});
                        
                        //reset main-page-slider height (possible changed by afterMove callback on narrow devices)
                        $('.main-page-slider').each( function(){
                            this.style.removeProperty( 'height' );  
                        } );
                        
                        $('.main-page-slider>.owl-controls .owl-buttons>div').each( function(){
                            this.style.removeProperty( 'top' );  
                        } );
                        $('.a13_tile_content').each( function(){
                            this.style.removeProperty( 'padding-top' );  
                        } );
                        
                        
                    }
                     
                }
                            
                
                
            },250));

            
            
            
            
        },
        
        
        header : {
            
            overlay_wrapper: function(){
                return "<div class='full_overlay close' data-anim_type='single'><div class='tile'></div></div>";
            },
            
            //animation of menu tiles
            toggle_tiles: function(){
                
                var anim = $('.full_overlay').hasClass('close') ? 'opening' : 'closing',
                    anim_type = $('.full_overlay').data('anim_type'),
                    tiles_count = $('.full_overlay .tile').length;

                history.pushState('', document.title, window.location.pathname);
                
                if(anim=='opening'){
                    $('.full_overlay').show().toggleClass('close',1);
                    
                    setTimeout(function(){
                    
                        $('.full_overlay .tile').toggleClass('open');
                    }, 1);
                }else{
                    $('.full_overlay .tile').toggleClass('open',1);
                    setTimeout(function(){
                        $('.full_overlay').hide().toggleClass('close',{duration:1 });
                        
                    }, 500);
                    
                }
                
                  
                
                
                          
            },
            
            init: function(){
                var $w = A13.header,
                    socials = $("#header .socials").html(),
                    nav_footer = $("#footer").html();
                //menu icon
                var svgIconConfig = {
                	hamburgerCross : {
                		url : G.imgurl+'/svg/hamburger.svg',
                        
                		animation : [
                			{ 
                				el : 'path:nth-child(1)', 
                				animProperties : { 
                					from : { val : '{"path" : "m 5.0916789,18.818994 53.8166421,0"}' }, 
                					to : { val : '{"path" : "M 12.972944,50.936147 51.027056,12.882035"}' }
                				} 
                			},
                			{ 
                				el : 'path:nth-child(2)', 
                				animProperties : { 
                					from : { val : '{"transform" : "s1 1", "opacity" : 1}', before : '{"transform" : "s0 0"}' }, 
                					to : { val : '{"opacity" : 0}' }
                				} 
                			},
                			{ 
                				el : 'path:nth-child(3)', 
                				animProperties : { 
                					from : { val : '{"path" : "m 5.0916788,44.95698 53.8166422,0"}' }, 
                					to : { val : '{"path" : "M 12.972944,12.882035 51.027056,50.936147"}' }
                				} 
                			}
                		]
                	}
                };
                
                menu_icon = new svgIcon( document.querySelector( '.si-icon-hamburger-cross' ), svgIconConfig, { 
                    size : { w : 70, h : 45 }, 
                    easing : mina.backin, 
                    speed: 600,
                    onToggle : function() { 
     
                        if(menu_is_opening){ menu_icon.toggle (true); return false;}
                
                        var to_toggle = $('#mobile_access').hasClass('mm-opened') ? 'close' : 'open';
                        
                        //temporary block click action
                        menu_is_opening = true;
                        
                        if( to_toggle == 'close' ){
                            //close menu
                            $('#mobile_access').mmenu().trigger( to_toggle+".mm" ); 
                            //make overlay visibile
                            setTimeout(function(){
                                $w.toggle_tiles();
                                
                            }, 500);
                            
                        }else{
                            //make overlay visibile
                            $w.toggle_tiles();
                            //open menu
                            setTimeout(function(){
                                $('#mobile_access').mmenu().trigger( to_toggle+".mm" ); 
                            }, 500);
                            
                        }
                        setTimeout(function(){
                           menu_is_opening = false;
                            
                        }, 1000);
                        
                    }
                } );
                $('#mobile_access').mmenu({
                    "header": {
                        "content": '<div class="nav_socials social_ribbon">'+socials+'</div>',
                        "add": true,
                        "update": true
                    },
                    "slidingSubmenus": false,
                    "footer": {
                        "content": '<div class="nav_footer">'+nav_footer+'</div>',
                        "add": true,
                        "update": false
                    },
                    "classes": "mm-fullscreen",
                    "offCanvas": {
                        "position" : "top",
                        "zposition" : "front"
                    },
                    "onClick" : {
                        "close":false
                    }
                }).on( "opening.mm", function() {
                    $('#mobile_access').find('.mCS-autoHide').removeClass('mCS-autoHide');
                    $('.mm-subopen','#mobile_menu').each( function(){
                        var item_w = $(this).next('a').find('span').width();    
                        $(this).css({'right':'calc(50% - '+( ( item_w ) + 20 )+'px)'});
                    } );
                    $('.mobile_menu_switch').toggleClass('opened');
                    history.pushState("", document.title, window.location.pathname + window.location.search);//remove hash
                   
                }).on( "opened.mm", function() {
                    $('.mm-footer').fadeIn();
                }).on( "closing.mm", function() {
                    $('.mm-footer').fadeOut(100);
                    $('.mobile_menu_switch').toggleClass('opened');
                    history.pushState("", document.title, window.location.pathname + window.location.search);//remove hash
                    
                }).removeClass('hide').wrap( function(){ return $w.overlay_wrapper(); } );

                //bind click action
                $('#mobile_menu a:not(.mm-subopen)').click( function( event ){
              
                    var force_scroll = false,
                        hash = '',
                        slide = '',
                        hash_i = $(this).attr("href").indexOf("#"),
                        slide_i = -1;
                    
                    if( hash_i != -1 ) {
                        hash = $(this).attr("href").substr(hash_i);
                        //hash = hash.substring( (hash.length-3),-3);
                    
                    } 
                    
                    if( hash != '' && $(hash).length ) {
                        force_scroll = true;
                        slide = $(hash).closest('.owl-item');
                        slide_i = slide.index();
                        
                    } 
                    
                    if( force_scroll || hash == '#page_very_top' ){
                        event.preventDefault();
                        history.pushState('', document.title, window.location.pathname);
                        
                        $('#mobile_access').mmenu().trigger( "close.mm" );
                        menu_icon.toggle();      
                                         
                        window.A13.header.toggle_tiles();
                        if( hash == '#page_very_top' ){
                            setTimeout(function() {
                                window.A13.page_slider.collapse_slider();
                                   
                            }, 500);
                        }else{
                            setTimeout(function() {
                                var opened = window.A13.page_slider.open_slide(slide);
                                if( !opened ){
                                    $('.main-page-slider').data('owlCarousel').goTo( slide_i );
                                }
                                   
                            }, 500);
                        }
                        
                    }
                    
                                       
                
                } ); 
                $('#mobile_menu').on('click','a.mm-subopen', function(){
                    $('#mobile_access').mCustomScrollbar("scrollTo",$(this).offset().top );
                } );    
            }
        },
        carousel : {
            init: function(){
                a13_carousels = [];//clear interior carousel cache
                $('.a13-custom-image-carousel').each( function(){
        
                    var $this_carousel      = $(this),
                        carousel_id         = $(this).attr('id'),
                        $carousel           = $(this).find('.vc-carousel-slideline-inner'),
                        slides              = $(this).data('per_view'),
                        single              = slides == 1,
                        animation_speed     = $(this).data('speed'),
                        scroll_count        = $(this).data('scroll'),
                        auto_play           = $(this).data('autoplay') === 'yes',
                        hide_nav            = $(this).data('hide_nav') === 'yes',
                        hide_pag            = $(this).data('hide_pag') === 'yes',
                        interval            = $(this).data('interval'),
                        slide_rows          = $(this).data('slide_rows'),
                        responsiveness      = [],
                        carousel_w          = $this_carousel.outerWidth(),
                        items_per_width     = Math.max(1,Math.floor(carousel_w/171)),
                        items_per_slide     = slide_rows * items_per_width,
                        padding             = ((carousel_w - (items_per_width * 171)) / 2) - 8,
                        $children ;
                        
                    
                    for (var i = 0; i < slides; i++) {
                       responsiveness.push([ Math.floor(i*(1920/slides)) ,(i+1)]);
                    }    
                      
                    //brake into rows
                    
                    if( slide_rows > 0 ){
                        while(($children = $('#'+carousel_id+' :not(.items_container)>.people_item:lt('+items_per_slide+')')).length) {
                            $children.wrapAll($('<div class="items_container" style="padding: 10px '+padding+'px;"></div>'));
                            
                        }
                    }
                    
                    $carousel.owlCarousel({
                        autoPlay : auto_play,
                        items: slides,
                        singleItem: single,
                        pagination : !hide_pag,
                        scrollPerPage : scroll_count,
                        slideSpeed : animation_speed,
                        paginationSpeed : interval,
                        //navigation : !hide_nav,
                        navigationText : false,
                        itemsCustom: responsiveness,
                    });
                    
                    
                    var j = a13_carousels.length;
                    
                    a13_carousels[j] = $carousel.data('owlCarousel');
                    
                });
                
                $('.a13-people-carousel-testimonial').on('click','.people_img',function(){
                    var item = $(this).closest('.owl-item'),
                        item_left = item.offset().left,
                        cloud_left = $('.a13_testimonial_cloud').offset().left;

                    
                    $('.a13_testimonial_cloud_triangle').velocity({'left':(item_left - cloud_left + 30) + 'px' });
                    if( $('.a13_testimonial_cloud_interior').hasClass('loading') ){
                        return false;
                    }
                    $('.a13_testimonial_cloud_interior').addClass('loading');
                    
                    $('.a13-people-carousel-testimonial').find('.owl-item').removeClass('active');
                    item.addClass('active');
                    A13.carousel.open_people(item);
                }); 
            },
            refresh: function (owl){
                
                var container           = $(owl.$elem).parent().parent().parent();
        
                var slide_rows          = container.data('slide_rows'),
                    carousel_id         = container.attr('id'),
                    carousel_w          = container.width(),
                    items_per_width     = Math.max(1,Math.floor(carousel_w/171)),
                    items_per_slide     = slide_rows * items_per_width,
                    padding             = ((carousel_w - (items_per_width * 171)) / 2) - 8,
                    $children;
                
                if( slide_rows > 0 && owl !== undefined ){
                
                    owl.destroy();    
                    //remove previous containers
                    if(container.find('.items_container').length > 0){
                        container.find('.people_item').unwrap();
                    }
                    
                    
                    //brake into rows
                    while(($children = $('#'+carousel_id+' :not(.items_container)>.people_item:lt('+items_per_slide+')')).length) {
                        $children.wrapAll($('<div class="items_container" style="padding: 10px '+padding+'px;"></div>'));
                    }
                    owl.reinit();
                }
                     
                
            },
            open_people: function(item){
                
                var people_url = $(item).find('.people_item').data('url'),
                    people_container = $(item).closest('.wpb_wrapper').find('.a13_testimonial_cloud_interior');

                //people_container.html('');
                
                $.get(people_url, {'ie' : (new Date()).getTime(),'mode':'modal'}, function(result){
                    var $result = $(result);
               
                    people_container.removeClass('loading').addClass('loaded').html($result.find('#content').html());
                    
            		people_container.find('.a13_testimonial_cloud_interior').hide().waitForImages(function() {
            			
                        window.A13P.a13_shortcodes();
                        
                        people_container.find('.a13_testimonial_cloud_interior').fadeIn();
                        
            		});			  
                    
                }, 'html');
                
            },
        },
        page_slider :{
            
            
            init: function(){
                
                $('.main-page-slider').owlCarousel({
                    singleItem : true,
                    rewindNav: false,
                    navigation: true,
                    pagination: false,
                    addClassActive: true,
                    slideSpeed: 500,
                    itemsDesktop : false,
                    itemsDesktopSmall : false,
                    itemsTablet: false,
                    itemsMobile : false,
                    //autoHeight : true,
                    navigationText: ['<div><h3 class="a13nav_text"></h3><span></span></div>','<div><h3 class="a13nav_text"></h3><span></span></div>'],
                    
                    beforeInit : function(){
                    
                        if( !page_slider_beforeinit ){
                            page_slider_beforeinit = true;
                            //remove empty paragraphs
                            $('.main-page-slider').find('p:empty').remove();
    
                            //panels scrolling
                            $(".pure_page_wrapper").each( function(){
                                var theme_name = $(this).hasClass('dark') ? "minimal" : "minimal-dark";
                                $(this).mCustomScrollbar({
                        			theme:theme_name,
                                    mouseWheel:{ scrollAmount: G.mousewheel_speed },
                                    
                        		});
                            } );
                            
                            $(".a13_row_container").each( function(){
                                var theme_name = $(this).hasClass('dark') ? "minimal" : "minimal-dark";
                                $(this).mCustomScrollbar({
                        			theme:theme_name,
                                    
                                    mouseWheel:{ scrollAmount: G.mousewheel_speed },                                
                                    callbacks:{
                						whileScrolling :function(){
                                            var element = $(this).find('.a13_row_container');
                                            //console.log(element);
                                            if ( element.hasClass('with-parallax') ){
                                            
                                                var ratio = element.data('a13_parallax_speed');
                                                
                                                element.css({ 'backgroundPosition' : '50% '+( ( this.mcs.topPct ) * ratio )+'%' });
                                                    
                                            }
                                            
                                            
                                            
                                            
                                        }
                					}
                                    
                        		});
                            } );
                                                        
                            //console.log('beforeInit event');
                        }
                        
                        
                    },
                    afterInit : function(){      
                        var slider_w = $('.main-page-slider>.owl-wrapper-outer').outerWidth(),
                            class_name = 'a13psic_'+collapsed_items_count,
                            collapsed_slider_sesttings = {items:collapsed_items_count, singleItem: false,navigationText: ['<div></div>','<div></div>'],};
                                                
                        window.A13.page_slider.set_nav(this.owl.currentItem);
                        
                        //buffer slides withot tiles, only once
                        if( !slides_cache_loaded ){
                            $('.main-page-slider>div>div>div.owl-item>.owl_row_wrap:not(.with_tile)').each( function(){
                                var i = $(this).parent().index();
                                slides_cache[i] = $(this).parent().html();
                                slides_cache_loaded = true;
                            } );
                        }                                                
                        
                        //touch events
                        
                        $('.main-page-slider>.owl-controls').on( 'touchstart','.owl-buttons>div', function(){ 
                         
                            var color = $(this).attr('data-lead_color'); 
                            
                            //$(this).attr('style', 'background-color: '+color+' !important;'); 
                            this.style.setProperty( 'background-color', color, 'important' );   
                                
                            $(this).addClass('touched'); 
                          
                        } ).on('mouseenter','.owl-buttons>div', function(e) {
                        	var color = $(this).attr('data-lead_color'); 
                            
                            this.style.setProperty( 'background-color', color, 'important' );    
                            $(this).addClass('touched'); 
                            
                        }).on('mouseleave','.owl-buttons>div', function(e) {
                        	
                            $(this).removeClass('touched');
                            //$(this).attr({'style':'display: block;' });
                            $(this).css({'display':'block' });
                            this.style.removeProperty( 'background-color' );   
                            

                        });
                        
                        $('.main-page-slider').on( 'touchstart', function(){ 
                         
                            $('.main-page-slider').addClass('touched');
                            
                        } ).on('mouseenter', function(e) {
                        
                            $('.main-page-slider').addClass('touched');
                            
                        }).on('mouseleave', function(e) {
                        	
                            $('.main-page-slider').removeClass('touched');
                                                        
                            
                        }).on('click', function(e) {
                        	
                            $(this).removeClass('touched');
                            
                            $(this).attr({'style':'display: block;' });
                        });
                        
                        //console.log('afterInit event');
                                      
                        
                        if(!initial_open && !main_slider_initiated && hash_from_url == ''){
                        
                            window.A13.page_slider.toggle_slider(-1);
                            
                        }
                        main_slider_initiated = true;
                        
                    },
                    
                    
                    afterMove : function(){
                        // fill the 'next' navigation button ('prev' is disabled anyway)
                        //$('.main-page-slider .owl-next')                   
                        window.A13.page_slider.set_nav(this.owl.currentItem);
                        if(isTouchScr){
                        
                            $('.main-page-slider .owl-buttons>div').removeClass('touched');
                            $('.main-page-slider .owl-buttons>div').attr({'style':'display: block;' });
                        }
                        
                        //move the footer up
                        if( $body.hasClass('no_custom_scroll') && $('#mid').hasClass('a13_opened') ){
                            //get visible slide height
                            var slide_h = $('.main-page-slider>.owl-wrapper-outer>.owl-wrapper>.owl-item.active').height();
                            $('.main-page-slider').velocity({'height':slide_h+'px'});


                        }

                        if( $('#mid').hasClass('a13_opened') ){

                            var hash_link = $('.main-page-slider>.owl-wrapper-outer>.owl-wrapper>.owl-item.active .a13_row_container').attr('id');
                            history.pushState({id:Math.floor((Math.random() * 1000) + 1)}, '', '#'+hash_link);
                            
                        }
                        //console.log('afterMove event');
                        
                                          
                        
                    }
                
                });  
                //$('.main-page-slider .owl-buttons>div').on( 'mouseout', function(){ $(this).attr({'style':'display: block;' }); } );
                $('.main-page-slider').on('click', '.a13_tile', function(){ window.A13.page_slider.toggle_slider( $(this).closest('.owl-item') ); } );
                
            
                
                
            },
            
            set_nav: function( curItem ){
                
                var prev_item = $('.main-page-slider>.owl-wrapper-outer>.owl-wrapper>.owl-item:eq('+(curItem - 1)+')').find('.owl_row_wrap'),
                    next_item = $('.main-page-slider>.owl-wrapper-outer>.owl-wrapper>.owl-item:eq('+(curItem + 1)+')').find('.owl_row_wrap'),
                    on_prev = ( $('.main-page-slider>.owl-controls>.owl-buttons>.owl-prev').length && $('.main-page-slider>.owl-controls>.owl-buttons>.owl-prev').is(":hover") ),
                    on_next = ( $('.main-page-slider>.owl-controls>.owl-buttons>.owl-next').length && $('.main-page-slider>.owl-controls>.owl-buttons>.owl-next').is(":hover") ),
                    hover_sel = '',
                    is_opened = $('#mid').hasClass('a13_opened');
                
                if(on_prev){
                    hover_sel = '.owl-prev';
                }
                if(on_next){
                    hover_sel = '.owl-next';
                }
                
                
                if( !is_opened ){
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-prev').attr( {'data-lead_color':''} );
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-next').attr( {'data-lead_color':''} );
                    $('.main-page-slider>.owl-controls>.owl-buttons>div').off( 'mouseover.a13');
                    return true;
                }else{
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-prev').attr( {'data-lead_color':prev_item.data('a13row_lead_color')} );
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-prev>div').css({'background-color':prev_item.data('a13row_lead_color')});
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-prev').find('.a13nav_text').html( prev_item.data('a13row_subtitle') );
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-prev').find('span').attr({'class':''}).addClass( prev_item.data('a13row_icon') );
                    
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-next').attr( {'data-lead_color':next_item.data('a13row_lead_color')} );
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-next>div').css({'background-color':next_item.data('a13row_lead_color')});
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-next').find('.a13nav_text').html( next_item.data('a13row_subtitle') );
                    $('.main-page-slider>.owl-controls>.owl-buttons>.owl-next').find('span').attr({'class':''}).addClass( next_item.data('a13row_icon') );
                    
                }
                
                if( hover_sel != ''){
                    $('.main-page-slider>.owl-controls>.owl-buttons>div')
                    //.trigger('mouseout')
                    //.fadeOut(100)
                    .off( 'mouseover.a13')
                    .on( 'mouseover.a13', function(){ 
                        var color = $(this).attr('data-lead_color'); 
                        $(this).addClass('touched');
                        this.style.setProperty( 'background-color', color, 'important' );   
                    })
                    .filter(hover_sel)
                    .trigger('mouseover.a13');
                }else{
                    $('.main-page-slider>.owl-controls>.owl-buttons>div')
                    .trigger('mouseout')
                    .fadeOut(100)
                    .off( 'mouseover.a13')
                    .on( 'mouseover.a13', function(){ 
                        var color = $(this).attr('data-lead_color'); 
                        this.style.setProperty( 'background-color', color, 'important' );   
                    }).parent().parent().find('.owl-buttons>div').fadeIn(100);
                }
                //check if there's a map
                if( !block_initializing_map && !map_initialized && $('.main-page-slider>div>div>div.owl-item:eq('+curItem+') #a13-map-canvas').length > 0 ){
                    a13_gmaps_initialize();
                    map_initialized = true;
                }
                
         
            },
            
            toggle_slider : function( obj ){
                
                
                var no_custom_scroll = $body.hasClass('no_custom_scroll'),
                    slider_w = $('.main-page-slider>.owl-wrapper-outer').outerWidth(),
                    collapsed_items_count = Math.min(Math.floor(slider_w/min_item_width),max_items_count),
                    class_name = 'a13psic_'+collapsed_items_count,
                    collapsed_slider_sesttings = {items:collapsed_items_count, singleItem: false,navigationText: ['<div></div>','<div></div>'],},
                    was_opened = $('#mid').hasClass('a13_opened'),
                    clicked_item = '',
                    clicked_item_i = 0,
                    fast = true;
                if(obj != -1){
                    clicked_item = obj,
                    clicked_item_i = obj.index();
                    fast = false;
                }
                
                
                //unbind click
                $('.main-page-slider').off('click');
                
                //if( no_custom_scroll)
                if(was_opened){
                    //closing content

                    history.pushState("", document.title, window.location.pathname + window.location.search);//remove hash
                    window.setTimeout( function(){
                        
                        //hide other content blocks
                        $('.main-page-slider>div>div>div.owl-item:not(:eq('+clicked_item_i+')) .mCustomScrollbar')
                            .mCustomScrollbar("disable")
                            .css( { width : '0',left: '0',display:'none' } );
                            
                        $('#mid').removeClass('a13_opening_done');
                    }, 1);
                    
                    window.setTimeout( function(){
                        //return false;
                        //remove with animation visible content block
                        $('.main-page-slider>div>div>div.owl-item:eq('+clicked_item_i+') .mCustomScrollbar')
                        .velocity( { left : '-100%' },{duration:(fast ? 1 : 500 )});
                        
                    }, (fast ? 1 : 100 ) );
                    
                    window.setTimeout( function(){
                        //return false;
                        
                        $('.main-page-slider').data('owlCarousel').goTo( Math.floor( (clicked_item_i)/collapsed_items_count ) );  
                        //change tile width to fit according to tile amount
                        $('.main-page-slider>div>div>div.owl-item:eq('+clicked_item_i+') .mCustomScrollbar')
                        .css({'top':'0',width : '0',display:'none'})
                        .mCustomScrollbar("disable");
                        
                        $('.a13_tile').velocity({'width':(slider_w/collapsed_items_count)+'px'},{duration:(fast ? 1 : 500 )});
                        
                    }, (fast ? 1 : 610 ));
                    
                    window.setTimeout( function(){
                        //return false;
                        //tile all together
                        $('.main-page-slider>div>div>div.owl-item').velocity({'width':(slider_w/collapsed_items_count)+'px'},{ duration: (fast ? 1 : 500 )});
                        //$window.trigger( 'resize' );
                        
                    },(fast ? 1 : 1650 ));
                    
                    window.setTimeout( function(){
                        //return false;
                        
                        //remove items without tile
                        $('.main-page-slider').find('.owl-item>.owl_row_wrap:not(.with_tile)').each( function(){
                            var i = $(this).parent().index();
                            
                            $('.main-page-slider').data('owlCarousel').removeItem(i);
                             
                        } );
                        
                        $('.main-page-slider').data('owlCarousel').reinit(collapsed_slider_sesttings);
                                
                        //console.log(a13_carousels);
                        $.each( a13_carousels, function( index, owl ) {
                            
                            if ( owl != undefined ){
                            //console.log(owl);
                                owl.destroy();
                            }
                        });
                        $('#mid').addClass(class_name).toggleClass('a13_opened').removeClass('update_carousels');;
                        window.A13.page_slider.set_nav(clicked_item_i);
                        //$('.main-page-slider').data('owlCarousel').goTo( Math.floor( (clicked_item_i)/collapsed_items_count ) );
                    }, (fast ? 1 : 2100 ) );
                    
                    
            
                }else{
                    //open
                    var hash_link = clicked_item.find('.a13_row_container').attr('id');
                    history.pushState({id:Math.floor((Math.random() * 1000) + 1)}, '', '#'+hash_link);


                    window.setTimeout( function(){
                        //get back all slides without tile
                        block_initializing_map = true;
                        $.each( slides_cache, function( index, value ) {
                            if ( value !== undefined ){
                                $('.main-page-slider').data('owlCarousel').addItem(value ,index);
                                
                                
                            }
                        });
                        
                        
                        $('#mid').toggleClass('a13_opened');
                    }, 1);
                    
                    window.setTimeout( function(){
                        //return false;
                        $('.a13_tile').velocity({'width':'164px'},{ duration: 300});
                        
                        //make slides wide
                        $('.main-page-slider>div>div>div.owl-item').velocity({'width':(slider_w)+'px'},500);
                        
                    }, 100);
                    
                    window.setTimeout( function(){
                        //return false;
                        $('.main-page-slider').data('owlCarousel').reinit({ singleItem: true,navigationText: ['<div><h3 class="a13nav_text"></h3><span></span></div>','<div><h3 class="a13nav_text"></h3><span></span></div>']});
                        $('.main-page-slider').data('owlCarousel').goTo(clicked_item_i);
                        
                    }, 600);
                    
                    
                    //show clicked item
                   
                    window.setTimeout( function(){
                        //return false;
                        
                        //prepare clicked item    
                        $('.main-page-slider>div>div>div.owl-item:eq('+clicked_item_i+') .mCustomScrollbar')
                        .css({ width: 'auto',left : '-100%',display:'block' }).mCustomScrollbar("update");
                        
                        //console.log($('.main-page-slider>div>div>div.owl-item:eq('+clicked_item_i+') .mCustomScrollbar').height());
                        $('#mid').addClass('a13_opening_done');
                        
                        if( no_custom_scroll){
                                                        
                            
                            var slide_h = $('.main-page-slider>.owl-wrapper-outer>.owl-wrapper>.owl-item.active').height();
                            $('.main-page-slider').velocity({'height':slide_h+'px'});
                            
                        }
                        $window.trigger( 'resize' );
                       
                    }, 1100);
                    window.setTimeout( function(){
                        //return false;
                        
                        //show clicked item
                        $('.main-page-slider>div>div>div.owl-item:eq('+clicked_item_i+') .mCustomScrollbar')
                        .velocity( { left : '0' }, { duration: 500});
                        
                    }, 1300);
                    
                    window.setTimeout( function(){
                        //return false;
                        
                        //check if there's a map
                        if( !map_initialized && $('.main-page-slider>div>div>div.owl-item:eq('+clicked_item_i+') #a13-map-canvas').length > 0 ){
                            a13_gmaps_initialize();
                            map_initialized = true;
                        }
                        //make all slide's content visibile
                        $('.main-page-slider>div>div>div.owl-item .mCustomScrollbar').css({ width: 'auto', left:0, display: 'block' }).mCustomScrollbar("update");
                        
                    }, 1800);
                    
                    window.setTimeout( function(){
                        //return false;
                        $('.a13-custom-image-carousel').each( function(){
                            
                            while( !$(this).find('.people_item').parent().hasClass('vc-carousel-slideline-inner') ){
                                $(this).find('.people_item').unwrap();
                            }
                            
                                                    
                        
                        } );
                        window.A13.carousel.init();       
                        $window.trigger( 'resize' );
                        
                        $('#mid').removeClass(class_name).addClass('update_carousels');
                        window.A13.page_slider.set_nav(clicked_item_i);
                        
                        block_initializing_map = false;
                    }, 1900);
                    
                }
                
                
                
                if(obj != -1){
                    $('.main-page-slider').on('click', '.a13_tile', function(){ window.A13.page_slider.toggle_slider( $(this).closest('.owl-item') ); } );
                }
                //window.A13.page_slider.toggle_slider();
                
            },
            
            open_slide: function( obj ){
                var was_opened = $('#mid').hasClass('a13_opened');
                
                if ( was_opened ){
                    return false;
                }
                
                window.A13.page_slider.toggle_slider( obj );
                return true;
            },
            collapse_slider: function( ){
                var was_opened = $('#mid').hasClass('a13_opened');
                
                if ( was_opened ){
                    var first = $('.main-page-slider>div>div>div.owl-item:eq(0)')
                    window.A13.page_slider.toggle_slider( first );
                }else{
                    $('.main-page-slider').data('owlCarousel').goTo( 0 );
                }
                return true;
            }
        
        }
        
    
    }
  
    //make things alive
    
    $(document).ready( function(){
        //override vc bakery function to run masonry more flexible
        
        window.vc_teaserGrid = function(){
            var layout_modes = {
              fitrows:'fitRows',
              masonry:'masonry'
            }
            
            jQuery('.wpb_grid .teaser_grid_container:not(.wpb_carousel), .wpb_filtered_grid .teaser_grid_container:not(.wpb_carousel)').each(function () {
                var $container = jQuery(this);
                var $thumbs = $container.find('.wpb_thumbnails');
                var layout_mode = $thumbs.attr('data-layout-mode');
                
                
                $thumbs.isotope({
                    // options
                    itemSelector:'.isotope-item',
                    layoutMode: 'packery',   
                });
                
                
                $container.find('.categories_filter a').data('isotope', $thumbs).click(function (e) {
                    e.preventDefault();
                    var $thumbs = jQuery(this).data('isotope');
                    jQuery(this).parent().parent().find('.active').removeClass('active');
                    jQuery(this).parent().addClass('active');
                    $thumbs.isotope({filter:jQuery(this).attr('data-filter')});
                });
                jQuery(window).resize(debounce( function(){$thumbs.isotope("layout");},250));
            });
        }
        
        A13 = window.A13;
        A13.rise();
        //display first testimonial
        $('.a13-people-carousel-testimonial .people_img:eq(0)').click();
        
        
    });
    
    $(window).load(function(){
        $("#preloader").velocity({'opacity':'0'},500, function(){
            $("#preloader").hide();
        } );
        setTimeout(function(){
            $(".mobile_menu_switch").fadeIn();
            $("#mid").velocity({'opacity':'1'});
        }, 500);
            
        
        
    });
   
    
    
})(jQuery, window, document);// JavaScript Document
