<?php
/**
 * The template for displaying Search Results pages.
 *
 */

if( have_posts() ):
    /* Search Count */

    $all_search = new WP_Query("s=$s&showposts=-1");
    $count = $all_search->post_count;
    wp_reset_query();

    get_header();
?>


<article id="content" class="clearfix main-page-slider" data-initial_open="on" data-max_tiles_count="1" data-min_tile_width="1">

    <div class="pure_page_wrapper owl_row_wrap">
<h1 class="page-title"><?php echo sprintf( __fe( '%1$d Search results for "%2$s"' ), $count, get_search_query() );?></h1>

        <div id="post-list">

            <?php
            /* Run the loop to output the post.
             * If you want to overload this in a child theme then include a file
             * called loop-single.php and that will be used instead.
             */
            get_template_part( 'loop' );
            ?>
            <?php a13_blog_nav(); ?>

        </div>

        <?php get_sidebar(); ?>


</article>

<?php
    get_footer();
else:
    global $a13_empty_error_msg;
    $a13_empty_error_msg =  sprintf( __fe( 'No Search results for "%1$s"' ), get_search_query() );
    get_template_part( '404' );
endif;
