<?php
/**
 * The Template for displaying portfolio items.
 *
 */
global $a13_option;
define( 'A13_WORK_PAGE', true );

the_post();
$is_protected = post_password_required();

if($is_protected){
    define( 'A13_PAGE_PROTECTED', true );
}


$featured_image = get_the_post_thumbnail( get_the_ID(), 'full' );
$thumb_id = get_post_thumbnail_id(get_the_ID());
$thumb_url_array = wp_get_attachment_image_src($thumb_id, 'thumbnail-size', true);

get_header();

//a13_title_bar();

?>

<article id="content" class="clearfix">



    <?php
    echo '<h2 class="post-title works">'.get_the_title().'</h2>';
    echo '<p class="posted_in">'.a13_posted_in().'</p>';
    if( $featured_image ) {echo '<div class="list" id="a13-full-photos"><a href="'.esc_url($thumb_url_array[0]).'" data-group="featured_image">'.$featured_image.'</a></div>';}
    
    $subtitle = '';
    
    //$subtitle = get_post_meta(get_the_ID(), '_subtitle', true);
    if( strlen($subtitle) ){
        echo '<h3 class="works-subtitle">'.$subtitle.'</h3>';
    }
    
    
    //password protected
    if($is_protected){
        echo get_the_password_form();
    }
    //normal
    else{
        $content_position = get_post_meta(get_the_ID(), '_content_position', true); //= left,right or under
?>

        <div id="post-<?php the_ID(); ?>" <?php post_class('content-'.$content_position); ?>>
            
            <?php
            
            //media collection as first element
            if($content_position === 'under'){
                echo a13_make_media_collection();
            }
            ?>
            <div class="work-content">

                <div class="real-content">

                    <?php the_content(); ?>

                    <div class="clear"></div>
                </div>
                

            </div>
            <?php
            //work-content is floating so media collection should be second
            if($content_position !== 'under'){
                echo a13_make_media_collection();
            }
            ?>
            <div class="clear"></div>

            <?php //a13_similar_posts(); ?>

        </div>
<?php
    }//end of non password protected
?>
  
</article>

<?php
    get_footer();
?>
