<?php
$output = $title = $link = $size = $zoom = $type = $bubble = $el_class = '';
extract(shortcode_atts(array(
    'title' => '',
    //'link' => 'https://maps.google.com/maps?q=New+York&hl=en&sll=40.686236,-73.995409&sspn=0.038009,0.078192',
    //'link' => '<iframe src="https://mapsengine.google.com/map/u/0/embed?mid=z4vjH8i214vQ.kj0Xiukzzle4" width="640" height="480"></iframe>',
    'size' => '300',
    'zoom' => 14, //depreceated from 4.0.2
    'type' => 'm', //depreceated from 4.0.2
    'bubble' => '', //depreceated from 4.0.2
    'el_class' => '',
    'gmaps_mode' => '',
    'gmaps_url' => '',
    'latlon' => '',
    'a13_gmaps_type' => 'ROADMAP',
    'marker_title' => '',
    'marker_desc' => ''
), $atts));

$link =  trim(vc_value_from_safe($link));
$bubble = ($bubble!='' && $bubble!='0') ? '&amp;iwloc=near' : '';
$size = str_replace(array( 'px', ' ' ), array( '', '' ), $size);

$el_class = $this->getExtraClass($el_class);
$el_class .= ($size=='') ? ' vc_map_responsive' : '';

if(is_numeric($size)) $link = preg_replace('/height="[0-9]*"/', 'height="'.$size.'"', $link);

$css_class = apply_filters( VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, 'wpb_gmaps_widget wpb_content_element' . $el_class, $this->settings['base'], $atts );



?>


<div class="<?php echo esc_attr($css_class); ?>">
	<?php echo wpb_widget_title(array('title' => $title, 'extraclass' => 'wpb_map_heading')); ?>
	<div class="wpb_wrapper">
		<div class="wpb_map_wraper">
            <div class="map-container" style="height:<?php echo $size.'px;';?>">
                <div id="a13-map-canvas"></div>
            </div>
            <script type="text/javascript" src="https://maps.googleapis.com/maps/api/js?sensor=false"></script>
            <script type="text/javascript">
            
                function a13_gmaps_initialize() {
                    
                    var latlng              = new google.maps.LatLng(<?php echo $latlon; ?>),
                            m_size              = new google.maps.Size(60,51),
                            m_start_point       = new google.maps.Point(0,0),
                            m_drop_point        = new google.maps.Point(30,51),
                            markerImage         = new google.maps.MarkerImage('<?php echo A13_TPL_GFX; ?>/pointer.png', m_size, m_start_point, m_drop_point);
        
                    var mapOptions = {
                        center: latlng,
                        mapTypeId: google.maps.MapTypeId.<?php echo $a13_gmaps_type; ?>,
                        disableDefaultUI:false,
                        scrollwheel: false,
                        zoomControl: true,
                        panControl: true,
                        draggable: false,
                        scaleControl: true,
                        zoom: <?php echo $zoom; ?>
                    };
        
                    var map = new google.maps.Map(document.getElementById("a13-map-canvas"),mapOptions);
        
                    var marker = new google.maps.Marker({
                        position: latlng,
                        flat: true,
                        icon : markerImage,
                        map: map,
                        title: <?php echo json_encode($marker_title); ?>
                    });
        
                    var contentString = <?php echo json_encode($marker_desc); ?>;
        
                    var infowindow = new google.maps.InfoWindow({
                        content: contentString,
                        maxWidth: 250
                    });
        
                    google.maps.event.addListener(marker, 'click', function() {
                        infowindow.open(map,marker);
                    });
                }
                
            </script>            
            
		</div>
	</div><?php echo $this->endBlockComment('.wpb_wrapper'); ?>
</div><?php echo $this->endBlockComment('.wpb_gmaps_widget'); ?>