<?php
// Our include
define('WP_USE_THEMES', false);
require_once( '../../../wp-load.php');

// Our variables
$postType 	= (isset($_GET['postType'])) ? $_GET['postType'] : 'post';
$category 	= (isset($_GET['category'])) ? $_GET['category'] : '';
$exclude 	= (isset($_GET['postNotIn'])) ? $_GET['postNotIn'] : '';
$numPosts 	= (isset($_GET['numPosts'])) ? $_GET['numPosts'] : 6;
$offset 	= (isset($_GET['offset'])) ? $_GET['offset'] : '';
$grid_template = (isset($_GET['grid_template'])) ? $_GET['grid_template'] : '';
$grid_item_layout_mode = (isset($_GET['item_layout_mode'])) ? $_GET['item_layout_mode'] : '';
$v_margin = (isset($_GET['v_margin'])) ? $_GET['v_margin'] : 0;
$h_margin = (isset($_GET['h_margin'])) ? $_GET['h_margin'] : 0;
$post_margin_class = (isset($_GET['margin_class'])) ? $_GET['margin_class'] : '';
$post_format_icons = array('video'=>'fa-play-circle-o', 'link'=>'fa-link', 'quote'=>'fa-quote-right');
$out = new stdClass();

if (!$offset > 0){
    //throw error
}
if ($offset == -1){
    $out->err = __fe('No more items to display');
    $out->ok = 0;
    echo json_encode($out);
    exit();
}

//Set up our initial query arguments
$args = array(
	'post_type' 		=> $postType,
	'posts_per_page' 	=> $numPosts,
    'offset'          	=> $offset,	
	'orderby'   		=> (isset($_GET['orderBy']) ? $_GET['orderBy'] : 'ID'),
	'order'     		=> (isset($_GET['order']) ? $_GET['order'] : 'DESC'),
	'post_status' 		=> 'publish',
    'grid_link_target' 	=> (isset($_GET['target']) ? $_GET['target'] : '_blank'),
);

if(!empty($exclude)){
	$exclude=explode(",",$exclude);
	$args['post__not_in'] = $exclude;
}

$my_query = new WP_Query($args);

$teasers = '';
$teaser_categories = Array();
$taxonomies = array();

if($postType === 'posts'){
    $grid_columns_count = 1;
    define('A13_POST_LIST', 1);
}
elseif($postType === 'work'){    
    array_push($taxonomies, 'genre');
}
elseif($postType === 'gallery'){ 
    array_push($taxonomies, 'kind');
}
elseif($postType === 'people'){
    array_push($taxonomies, 'group');
}
if($grid_template == 'filtered_grid' && empty($grid_taxomonies)) {
    $taxonomies = get_object_taxonomies(!empty($postType) ? $postType : get_post_types(array('public' => false, 'name' => 'attachment'), 'names', 'NOT'));
}

$link_target = $args['grid_link_target']=='_blank' ? ' target="_blank"' : '';
$ajax_anchor_class = '';
if ( $args['grid_link_target'] == 'ajax_to_container' ){
    $ajax_anchor_class = 'ajax_to_container';
}

$isotope_item = 'isotope-item';
$thumb_size = a13_teaser_thumb_size('apollo-post-brick', $numPosts);
$li_span_class = '';
$posts_found = 0;
$extra_classes = '';



while ( $my_query->have_posts() ) {
    $my_query->the_post();
    $post_id = $my_query->post->ID;
    $posts_found ++;

    $categories_css = '';
    $categories_names = '';
    if( $grid_template == 'filtered_grid' or true ) {
        /** @var $post_categories get list of categories */
        // $post_categories = get_the_category($my_query->post->ID);
        $post_categories = wp_get_object_terms($post_id, array_values($taxonomies));
        if(!is_wp_error($post_categories)) {
            foreach($post_categories as $cat) {
                if(!in_array($cat->term_id, $teaser_categories)) {
                    $teaser_categories[] = $cat->term_id;
                }
                $categories_css .= ' grid-cat-'.$cat->term_id;
                $categories_names .= ' '.$cat->name.',';
            }
        }

    }
    $categories_names = substr($categories_names,0,-1);

    ob_start();
    the_content();
    $temp = ob_get_clean();
    if( $temp != '' ){
        $full_content = $temp;
        $content = wp_strip_all_tags( $temp );
        $content = wp_trim_words( $content, 45 );
    }
    $post_title = get_the_title($post_id);

    

    $post_thumbnail = wpb_getImageBySize(array( 'post_id' => $post_id, 'thumb_size' => $thumb_size ));
    $thumbnail_addr = $post_thumbnail['p_img_large'][0];
    $thumbnail = $post_thumbnail['thumbnail'];
    
    
    // Link logic
    $link_image_start   = '<a class="link_image" href="'.esc_url(get_permalink($post_id)).'"'.$link_target.' title="'.sprintf( esc_attr__( 'Permalink to %s', 'a13_shortcodes' ), the_title_attribute( 'echo=0' ) ).'">';
    $link_title_start   = '<a class="link_title" href="'.esc_url(get_permalink($post_id)).'"'.$link_target.' title="'.sprintf( esc_attr__( 'Permalink to %s', 'a13_shortcodes' ), the_title_attribute( 'echo=0' ) ).'">';
    $link_image_end     = '<em></em></a>';
    $link_title_end     = '</a>';


    //ITEM HTML
    if($postType=='post'){
        
        $post_format = get_post_format( $post_id );
        
        $teasers .= '<li class="'.esc_attr($isotope_item.' '.$categories_css).' ready a13_latest_post '.apply_filters(VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, 'vc_teaser_grid_li').'">';
        ob_start();
        get_template_part( 'content', $post_format ); 
        $teasers .= ob_get_clean();
        
        $teasers .= '</li> ';
        
        $obj[] = $teasers;
        $teasers = '';
    }
    //works || galleries || people
    else{
        $alt_link       = get_post_meta($post_id, '_alt_link', true);
        $url            = (strlen($alt_link) > 0)? $alt_link : get_permalink();
        
        $post_subtitle = get_post_meta($post_id, '_subtitle', true);
        
        $brick_layout = 'over';
        $brick_layout_position = 'center';
        
 
        $item_w = $item_h = 1;
        $size_class = " w".$item_w." h".$item_h." ";
        
        $background_class = "g-link-bgimg_".$post_id;
        $extra_classes .= ".".$background_class."{background-image:url('".$thumbnail_addr."');}";            
        
        $background_color = get_post_meta($post_id, '_overlay_bg_color', true);
        $overlay_font_color = get_post_meta($post_id, '_overlay_font_color', true);
        
        
        $is_protected = post_password_required($post_id) ? 1 : 0;
        
        $overlay_image  = get_post_meta($post_id, '_overlay_image', true);
        
        //for people
        $display_as = '';
        if($postType == 'people'){
            $brick_layout = 'over';
            $display_as = get_post_meta($post_id, '_display_as', true);
            
            
            $overlay_font_color_class = "g-link-ovl_font_c_".$post_id;
            $extra_classes .= ".".$overlay_font_color_class.", .".$overlay_font_color_class.":hover{color:".$overlay_font_color.";}";      
            
                        
            $socials = array();
                
            
        }
        
        $block_link = ( $display_as != 'as_team' && $postType == 'people' ) ? 'block' : '' ;
        $cb_item = '';
        if( $display_as == 'as_image' && $postType == 'people' ){
            $block_link .= ' cb_image';
            $cb_item = 'yes';
        }
        

        $teasers .= '<li class="g-item ready '.apply_filters(VC_SHORTCODE_CUSTOM_CSS_FILTER_TAG, $li_span_class, 'vc_teaser_grid_li').' '.esc_attr($isotope_item.' '.$categories_css.' '.$size_class).'">';
        $teasers .= '<'.($cb_item == '' ? 'div' : 'a' ).' data-post_id="'.$post_id.'" class="g-link '.esc_attr($block_link.' '.$brick_layout_position.' '.$brick_layout.' '.$ajax_anchor_class).'" data-post-type="'.esc_attr($postType).'" '.($cb_item == '' ? 'data-href="'.esc_url($url).'"' : 'href="'.esc_url($thumbnail_addr).'"' ).' id="album-' . esc_attr($post_id) . '" data-pass-protection="'.esc_attr($is_protected).'">';
        $teasers .= '<i class="'.esc_attr($background_class).'"></i>';
        
        
        $teasers .= '<div class="overlay '.($display_as == 'as_quote' ? ' quote' : '').'" >';//overlay
        $teasers .= ( $overlay_image != '' ? '<img alt="'.__('overlay_image', 'a13_shortcodes').'" src="'.esc_url($overlay_image).'">' :'');
        
        if( $display_as == 'as_image' ){
            $teasers .= '<div class="overlay_icon '.esc_attr($overlay_font_color_class).'"><i class="fa fa-eye"></i></div>';
        }
        
        $teasers .= '</div>';//overlay end
        
        $teasers .= '<div class="cov '.($postType=='work' ? 'works' : '').($postType=='people' ? 'people'.($display_as == 'as_quote' ? ' quote' : '') : '').'" style="color:'.$overlay_font_color.';background-color:'.$background_color.';">';
        
        if( $postType == 'people' ){
            
            if( $display_as == 'as_team' ){
            
                $teasers .= '<span class="'.esc_attr($overlay_font_color_class).'"><strong>'.$post_title.'</strong><small>'.$post_subtitle.'</small></span>';
                $teasers .= a13_return_soc_icons($socials);
            
            }elseif( $display_as == 'as_quote' ){
                $teasers .= '<div class="'.esc_attr($overlay_font_color_class).'">'.$full_content.'<small>'.$post_title.'</small></div>';
            }else{
            }
            
        }else{
            $teasers .= $grid_item_layout_mode === 'overlay' ? '<em class="filling_table">' : '';
            $teasers .= '<span class="'.($grid_item_layout_mode === 'overlay' ? 'table_cell_center' : '' ).'">'.(($grid_item_layout_mode === 'overlay' && $overlay_image != '') ? '<img alt="'.__('overlay_image', 'a13_shortcodes').'" src="'.esc_url($overlay_image).'">' : '' ).'<strong>'.$post_title.'</strong><small>'.$categories_names.'</small></span>';
            $teasers .= ( $brick_layout == 'over' ? '<div class="subtitle">'.$post_subtitle.'</div>' : '' );
            $teasers .= $grid_item_layout_mode === 'overlay' ? '</em>' : '';
            $teasers .= $is_protected ? '<em class="filling_table pass_form"><span class="'.($grid_item_layout_mode === 'overlay' ? 'table_cell_center' : '' ).'"><span class="error"></span><div class="clearfix"></div><span>'.__('Enter password', 'a13_shortcodes').'</span><input type="password" class="post_password" name="post_password" data-post-id="'.esc_attr($post_id).'"><input type="button" class="submit_password" value="'.__('Unlock', 'a13_shortcodes').'"></span></em>' : '';
            //$teasers .= '<div class="cov-bg" style="'.(( $grid_item_layout_mode === 'overlay' && $background_color != '') ? 'background-color:'.$background_color.';' : '' ).'"></div>';
        }
        
        
        
        $teasers .= '</div>';//cov end
        
        
        
        
        
        $teasers .= '</'.($cb_item == '' ? 'div' : 'a' ).'>';

        $teasers .= '</li>';
        
        $obj[] = $teasers;
        $teasers = '';
        
    }


} // endwhile loop
wp_reset_query();
$items_style = '';
if( strlen($extra_classes) ){
    $items_style = "<style>".$extra_classes."</style>";
}

if( $posts_found > 0 ){
    $out->html = $obj;
    $out->css = $items_style;
    $out->ok = 1;
    $out->post_found = $posts_found;
}else{
    $out->err = __fe('No more items to display');
    $out->ok = 0;
}

echo json_encode($out);
?>
