<?php
/**
 * Plugin Name: Visual Composer extend by Apollo13
 * Description: Shortcodes for Apollo13 Themes with support for Visual Composer plugin.
 * Version: 1.0.9
 * Author: Apollo13
 * Author URI: http://apollo13.eu/
 * License: GPL2
 */
define('A13_SC_DIR', rtrim(plugin_dir_path( __FILE__ ),"/"));
define('A13_SC_URL', plugin_dir_url( __FILE__ ));
define('A13_SC_VERSION', '1.0.9');
include_once( ABSPATH . 'wp-admin/includes/plugin.php' );
if (is_plugin_active('js_composer/js_composer.php')) {
    vc_set_shortcodes_templates_dir(get_template_directory().'/vc_templates/');
}

add_action( 'plugins_loaded', 'apollo13_i18n' );

function apollo13_i18n() {
	load_plugin_textdomain( 'a13_shortcodes', false, dirname( plugin_basename( __FILE__ ) ) . '/languages' );
}

// don't load directly
if (!defined('ABSPATH')) die('-1');

/*
Display notice if Visual Composer is not installed or activated.
*/
if ( !defined('WPB_VC_VERSION') ) { add_action('admin_notices', 'vc_extend_notice'); return; }
function vc_extend_notice() {
  $plugin_data = get_plugin_data(__FILE__);
  echo '
  <div class="updated">
    <p>'.sprintf(__('<strong>%s</strong> requires <strong><a href="http://bit.ly/vcomposer" target="_blank">Visual Composer</a></strong> plugin to be installed and activated on your site.', 'vc_extend'), $plugin_data['Name']).'</p>
  </div>';
}


/*
 * Adds CSS files to front-end
 */
function a13_sc_styles($special_pass = false){
    if((is_admin() || 'wp-login.php' == basename($_SERVER['PHP_SELF'])) && !$special_pass){
        return;
    }

    wp_register_style( 'vc_extend', A13_SC_URL . 'vc_extend.css', array('js_composer_front'), A13_SC_VERSION);

    wp_enqueue_style('vc_extend');
}

function a13_sc_endBlockComment($string) {
    //return '';
    return ( !empty($_GET['wpb_debug']) && $_GET['wpb_debug']=='true' ? '<!-- END '.$string.' -->' : '' );
}

function a13_sc_getExtraClass($el_class) {
    $output = '';
    if ( $el_class != '' ) {
        $output = " " . str_replace(".", "", $el_class);
    }
    return $output;
}


/*
 * CSS Animation function from JS_composer
 */
function getCSSAnimation($css_animation) {
    $output = '';
    if ( $css_animation != '' ) {
        wp_enqueue_script( 'waypoints' );
        $output = ' wpb_animate_when_almost_visible wpb_'.$css_animation;
    }
    return $output;
}

/**
 * Returns current plugin version.
 *
 * @return string Plugin version
 */
function a13_sc_plugin_get_version() {
    if ( ! function_exists( 'get_plugins' ) )
        require_once( ABSPATH . 'wp-admin/includes/plugin.php' );
    $plugin_folder = get_plugins( '/' . plugin_basename( dirname( __FILE__ ) ) );
    $plugin_file = basename( ( __FILE__ ) );
    return $plugin_folder[$plugin_file]['Version'];
}

/*
Load plugin css and javascript files
*/
add_action('wp_enqueue_scripts', 'vc_extend_js_css');
function vc_extend_js_css() {
  
  // If you need any javascript files on front end, here is how you can load them.
  wp_enqueue_script( 'vc_extend_js', plugins_url('vc_extend.js', __FILE__), array('jquery') );
}

add_action( 'wp_enqueue_scripts', 'a13_sc_styles' );
// ADD SHORTCODES
require_once (A13_SC_DIR . '/a13_extra_params.php');
require_once (A13_SC_DIR . '/a13_shortcodes.php');

vc_remove_element("vc_wp_search");
vc_remove_element("vc_wp_meta");
vc_remove_element("vc_wp_recentcomments");
vc_remove_element("vc_wp_calendar");
vc_remove_element("vc_wp_pages");
vc_remove_element("vc_wp_tagcloud");
vc_remove_element("vc_wp_custommenu");
vc_remove_element("vc_wp_text");
vc_remove_element("vc_wp_posts");
vc_remove_element("vc_wp_links");
vc_remove_element("vc_wp_categories");
vc_remove_element("vc_wp_archives");
vc_remove_element("vc_wp_rss");
vc_remove_element("vc_posts_grid");

//vc_remove_element("vc_images_carousel");
vc_remove_element("vc_carousel");
vc_remove_element("vc_posts_slider");